#include "stdafx.h"
#include "StdioFileEX.h"

#define	SIZE_READ_BUF	(1024*1024*13)	// 13M

CStdioFileEX::CStdioFileEX(void)
: m_ReadBuf(NULL)
{
	m_ReadCnt = 0;
	m_CurPos = 0;
	m_ReadBuf = NULL;

// 2008/07/22 appended by yG for adjust a/d converter error ->
	memset(m_caSecondPreviousData, NULL, 3);
	memset(m_caFirstPreviousData, NULL, 3);
	memset(m_caCurrentData, NULL, 3);
// <- 2008/07/22 appended by yG for adjust a/d converter error
}

CStdioFileEX::~CStdioFileEX(void)
{
}

// OPEN
BOOL CStdioFileEX::OpenEX(LPCSTR lpszFileName, UINT nOpenFlags, CFileException * pError)
{
	BOOL	rt;

	if ((rt = Open(lpszFileName, nOpenFlags, pError)) != FALSE) {
		// OPEN
		m_ReadBuf = new char [SIZE_READ_BUF];
	} else {
		// OPENs
		m_ReadBuf = NULL;
	}
	return rt;
}

// CLOSE
void CStdioFileEX::CloseEX(void)
{
	Close();
	if (m_ReadBuf != NULL)
		delete [] m_ReadBuf;
	m_ReadBuf = NULL;
}


// ǂݍݏ
UINT CStdioFileEX::ReadEX(void * lpBuf, UINT nCount)
{
	UINT	size, cnt;

	if (m_ReadBuf == NULL)
		return 0;

	// cf[^wǂݍ݃TCYꍇVɓǂݍ
	size = m_ReadCnt - m_CurPos;
	if (size < nCount) {
		// cf[^擪ɃRs[
		if (size > 0)
			memcpy(m_ReadBuf, &m_ReadBuf[m_CurPos], size);
		// VɃf[^ǂ
		m_ReadCnt = Read(&m_ReadBuf[size], SIZE_READ_BUF - size);
		// READJEg͓ǂݍ݃JEg{Rs[JEg
		m_ReadCnt += size;
		m_CurPos = 0;
		size = m_ReadCnt - m_CurPos;
	}
	// ǂݍ݌㑫Ȃꍇ̂ŁAă`FbN
	if (size >= nCount)
		cnt = nCount;
	else
		cnt = size;

	// wǂݍ݃obt@Ƀf[^Rs[
	memcpy(lpBuf, &m_ReadBuf[m_CurPos], cnt);

// 2008/07/22 appended by yG for adjust a/d converter error ->
	memcpy(m_caSecondPreviousData, m_caFirstPreviousData, 3);	// 2Õf[^XV
	memcpy(m_caFirstPreviousData, m_caCurrentData, 3);			// 1Õf[^XV
	memcpy(m_caCurrentData, &m_ReadBuf[m_CurPos], 3);			// ݂̃f[^
// <- 2008/07/22 appended by yG for adjust a/d converter error

	m_CurPos += cnt;

	// Rs[TCYԒl
	return cnt;
}

// 2008/07/22 appended by yG for adjust a/d converter error ->
void
CStdioFileEX::GetSecondPrevious(char* out_caBuffer)
{
	// {֐́CxCyCzf[^̎擾݂̂ړIƂC
	// f[^擾̃obt@TCÝCK3ł邱ƂƂB

	// 2Õf[^擾
	memcpy(out_caBuffer, m_caSecondPreviousData, 3);
}
void
CStdioFileEX::GetFirstPrevious(char* out_caBuffer)
{
	// {֐́CxCyCzf[^̎擾݂̂ړIƂC
	// f[^擾̃obt@TCÝCK3ł邱ƂƂB

	// 1Õf[^擾
	memcpy(out_caBuffer, m_caFirstPreviousData, 3);
}
void
CStdioFileEX::GetFirstNext(char* out_caBuffer)
{
	// {֐́CxCyCzf[^̎擾݂̂ړIƂC
	// f[^擾̃obt@TCÝCK3ł邱ƂƂB

	// 1̃f[^擾
	// ݂̃obt@ɂ邩mF
	UINT a_ulSize = m_ReadCnt - m_CurPos;
	if (a_ulSize > 3)
	{
		// ݂̃obt@ɂꍇ́C
		// [hobt@Rs[
		memcpy(out_caBuffer, &m_ReadBuf[m_CurPos], 3);
	}
	else
	{
		// ݂̃obt@ɂȂꍇ́CVɓǂݍ
		if (a_ulSize > 0)
		{
			// r[ȈʒȕꍇCcf[^擪ɃRs[
			memcpy(m_ReadBuf, &m_ReadBuf[m_CurPos], a_ulSize);
		}
		// VɃf[^ǂ
		m_ReadCnt = Read(&m_ReadBuf[a_ulSize], SIZE_READ_BUF - a_ulSize);
		// READJEg͓ǂݍ݃JEg{Rs[JEg
		m_ReadCnt += a_ulSize;
		m_CurPos = 0;

		// f[^Ȃꍇ́C0Ƃ
		if ((m_ReadCnt - m_CurPos) < 3)
		{
			memset(out_caBuffer, NULL, 3);
		}
		else
		{
			// [hobt@Rs[
			memcpy(out_caBuffer, &m_ReadBuf[m_CurPos], 3);
		}
	}
}
void
CStdioFileEX::GetSecondNext(char* out_caBuffer)
{
	// {֐́CxCyCzf[^̎擾݂̂ړIƂC
	// f[^擾̃obt@TCÝCK3ł邱ƂƂB

	// 1̃f[^擾
	// ݂̃obt@ɂ邩mF
	UINT a_ulSize = m_ReadCnt - m_CurPos;
	if (a_ulSize > 6)
	{
		// ݂̃obt@ɂꍇ́C
		// [hobt@Rs[
		memcpy(out_caBuffer, &m_ReadBuf[m_CurPos+3], 3);
	}
	else
	{
		// ݂̃obt@ɂȂꍇ́CVɓǂݍ
		// cf[^擪ɃRs[
		memcpy(m_ReadBuf, &m_ReadBuf[m_CurPos], a_ulSize);
		// VɃf[^ǂ
		m_ReadCnt = Read(&m_ReadBuf[a_ulSize], SIZE_READ_BUF - a_ulSize);
		// READJEg͓ǂݍ݃JEg{Rs[JEg
		m_ReadCnt += a_ulSize;
		m_CurPos = 0;

		// f[^Ȃꍇ́C0Ƃ
		if ((m_ReadCnt - m_CurPos) < 3)
		{
			memset(out_caBuffer, NULL, 3);
		}
		else
		{
			// [hobt@Rs[
			memcpy(out_caBuffer, &m_ReadBuf[m_CurPos+3], 3);
		}
	}
}
// <- 2008/07/22 appended by yG for adjust a/d converter error